/* src/language/data-io/file-handle.c		-*- mode: c; buffer-read-only: t -*-

   Generated by q2c from src/language/data-io/file-handle.q.
   Do not modify!
 */
#line 1 "src/language/data-io/file-handle.q"
/* PSPP - a program for statistical analysis.
   Copyright (C) 1997-9, 2000, 2006, 2010, 2011, 2012, 2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <config.h>

#include "data/file-handle-def.h"

#include <limits.h>
#include <errno.h>
#include <stdlib.h>

#include "data/file-name.h"
#include "data/session.h"
#include "data/variable.h"
#include "language/command.h"
#include "language/data-io/file-handle.h"
#include "language/lexer/lexer.h"
#include "libpspp/assertion.h"
#include "libpspp/cast.h"
#include "libpspp/message.h"
#include "libpspp/str.h"

#include "gl/xalloc.h"

#include "gettext.h"
#define _(msgid) gettext (msgid)

#line 48 "src/language/data-io/file-handle.c"
#include <stdlib.h>

#include "data/settings.h"
#include "data/variable.h"
#include "language/lexer/lexer.h"
#include "language/lexer/subcommand-list.h"
#include "language/lexer/variable-parser.h"
#include "libpspp/assertion.h"
#include "libpspp/cast.h"
#include "libpspp/message.h"
#include "libpspp/str.h"

#include "gl/xalloc.h"

#line 42 "src/language/data-io/file-handle.q"


#line 66 "src/language/data-io/file-handle.c"
#line 54 "src/language/data-io/file-handle.q"
#line 68 "src/language/data-io/file-handle.c"
struct dataset;
/* Settings for subcommand specifiers. */
enum
  {
    FH_CHARACTER = 1000,
    FH_BINARY,
    FH_IMAGE,
    FH_360,
    FH_LF,
    FH_CRLF,
    FH_FIXED,
    FH_F,
    FH_VARIABLE,
    FH_V,
    FH_SPANNED,
    FH_VS
  };

#define MAXLISTS 10
/* FILE HANDLE structure. */
struct cmd_file_handle
  {
    /* NAME subcommand. */
    int sbc_name;
    char *s_name;

    /* LRECL subcommand. */
    int sbc_lrecl;
    long n_lrecl[MAXLISTS];

    /* TABWIDTH subcommand. */
    int sbc_tabwidth;
    long n_tabwidth[MAXLISTS];

    /* MODE subcommand. */
    int sbc_mode;
    long mode;

    /* ENDS subcommand. */
    int sbc_ends;
    long ends;

    /* RECFORM subcommand. */
    int sbc_recform;
    long recform;

    /* ENCODING subcommand. */
    int sbc_encoding;
    char *s_encoding;
  };

/* Command parsing functions. */
static int parse_file_handle (struct lexer *, struct dataset *, struct cmd_file_handle *, void *);
static void free_file_handle (struct cmd_file_handle *);

#line 55 "src/language/data-io/file-handle.q"
#line 125 "src/language/data-io/file-handle.c"
static int
parse_file_handle (struct lexer *lexer, struct dataset *ds UNUSED, struct cmd_file_handle *p, void *aux UNUSED)
{
  p->sbc_name = 0;
  p->s_name = NULL;
  p->sbc_lrecl = 0;
  {
    int i;
    for (i = 0; i < MAXLISTS; ++i)
      p->n_lrecl[i] = LONG_MIN;
  }
  p->sbc_tabwidth = 0;
  {
    int i;
    for (i = 0; i < MAXLISTS; ++i)
      p->n_tabwidth[i] = LONG_MIN;
  }
  p->sbc_mode = 0;
  p->mode = FH_CHARACTER;
  p->sbc_ends = 0;
  p->ends = -1;
  p->sbc_recform = 0;
  p->recform = -1;
  p->sbc_encoding = 0;
  p->s_encoding = NULL;
  for (;;)
    {
      if (lex_match_id (lexer, "NAME"))
        {
          lex_match (lexer, T_EQUALS);
          p->sbc_name++;
          if (p->sbc_name > 1)
            {
              lex_sbc_only_once ("NAME");
              goto lossage;
            }
          if (!lex_force_string (lexer))
            return false;
          free(p->s_name);
          p->s_name = ss_xstrdup (lex_tokss (lexer));
          lex_get (lexer);
        }
      else if (lex_match_id (lexer, "LRECL"))
        {
          lex_match (lexer, T_EQUALS);
          p->sbc_lrecl++;
          if (p->sbc_lrecl > 1)
            {
              lex_sbc_only_once ("LRECL");
              goto lossage;
            }
          {
            int x;
            if (!lex_force_int (lexer))
              goto lossage;
            x = lex_integer (lexer);
            lex_get(lexer);
            p->n_lrecl[p->sbc_lrecl - 1] = x;
          }
        }
      else if (lex_match_id (lexer, "TABWIDTH"))
        {
          lex_match (lexer, T_EQUALS);
          p->sbc_tabwidth++;
          if (p->sbc_tabwidth > 1)
            {
              lex_sbc_only_once ("TABWIDTH");
              goto lossage;
            }
          {
            int x;
            if (!lex_force_int (lexer))
              goto lossage;
            x = lex_integer (lexer);
            lex_get(lexer);
            p->n_tabwidth[p->sbc_tabwidth - 1] = x;
          }
        }
      else if (lex_match_id (lexer, "MODE"))
        {
          lex_match (lexer, T_EQUALS);
          p->sbc_mode++;
          if (p->sbc_mode > 1)
            {
              lex_sbc_only_once ("MODE");
              goto lossage;
            }
          while (lex_token (lexer) != T_SLASH && lex_token (lexer) != T_ENDCMD)
            {
              if (lex_match_id (lexer, "CHARACTER"))
                p->mode = FH_CHARACTER;
              else if (lex_match_id (lexer, "BINARY"))
                p->mode = FH_BINARY;
              else if (lex_match_id (lexer, "IMAGE"))
                p->mode = FH_IMAGE;
              else if (lex_match_int (lexer, 360))
                p->mode = FH_360;
              else
                {
                  lex_error (lexer, NULL);
                  goto lossage;
                }
              lex_match (lexer, T_COMMA);
            }
        }
      else if (lex_match_id (lexer, "ENDS"))
        {
          lex_match (lexer, T_EQUALS);
          p->sbc_ends++;
          if (p->sbc_ends > 1)
            {
              lex_sbc_only_once ("ENDS");
              goto lossage;
            }
          while (lex_token (lexer) != T_SLASH && lex_token (lexer) != T_ENDCMD)
            {
              if (lex_match_id (lexer, "LF"))
                p->ends = FH_LF;
              else if (lex_match_id (lexer, "CRLF"))
                p->ends = FH_CRLF;
              else
                {
                  lex_error (lexer, NULL);
                  goto lossage;
                }
              lex_match (lexer, T_COMMA);
            }
        }
      else if (lex_match_id (lexer, "RECFORM"))
        {
          lex_match (lexer, T_EQUALS);
          p->sbc_recform++;
          if (p->sbc_recform > 1)
            {
              lex_sbc_only_once ("RECFORM");
              goto lossage;
            }
          while (lex_token (lexer) != T_SLASH && lex_token (lexer) != T_ENDCMD)
            {
              if (lex_match_id (lexer, "FIXED"))
                p->recform = FH_FIXED;
              else if (lex_match_id (lexer, "F"))
                p->recform = FH_F;
              else if (lex_match_id (lexer, "VARIABLE"))
                p->recform = FH_VARIABLE;
              else if (lex_match_id (lexer, "V"))
                p->recform = FH_V;
              else if (lex_match_id (lexer, "SPANNED"))
                p->recform = FH_SPANNED;
              else if (lex_match_id (lexer, "VS"))
                p->recform = FH_VS;
              else
                {
                  lex_error (lexer, NULL);
                  goto lossage;
                }
              lex_match (lexer, T_COMMA);
            }
        }
      else if (lex_match_id (lexer, "ENCODING"))
        {
          lex_match (lexer, T_EQUALS);
          p->sbc_encoding++;
          if (p->sbc_encoding > 1)
            {
              lex_sbc_only_once ("ENCODING");
              goto lossage;
            }
          if (!lex_force_string (lexer))
            return false;
          free(p->s_encoding);
          p->s_encoding = ss_xstrdup (lex_tokss (lexer));
          lex_get (lexer);
        }
      else if ( settings_get_syntax () != COMPATIBLE && lex_match_id(lexer, "ALGORITHM"))
        {
          lex_match (lexer, T_EQUALS);
          if (lex_match_id(lexer, "COMPATIBLE"))
            settings_set_cmd_algorithm (COMPATIBLE);
          else if (lex_match_id(lexer, "ENHANCED"))
            settings_set_cmd_algorithm (ENHANCED);
          }
        if (!lex_match (lexer, T_SLASH))
          break;
      }

    if (lex_token (lexer) != T_ENDCMD)
      {
        lex_error (lexer, _("expecting end of command"));
        goto lossage;
      }

  return true;

lossage:
  free_file_handle (p);
  return false;
}

static void
free_file_handle (struct cmd_file_handle *p)
{
  free (p->s_name);
  free (p->s_encoding);
}
#line 56 "src/language/data-io/file-handle.q"

int
cmd_file_handle (struct lexer *lexer, struct dataset *ds)
{
  struct fh_properties properties;
  struct cmd_file_handle cmd;
  struct file_handle *handle;
  enum cmd_result result;
  char *handle_name;

  result = CMD_CASCADING_FAILURE;
  if (!lex_force_id (lexer))
    goto exit;

  handle_name = xstrdup (lex_tokcstr (lexer));
  handle = fh_from_id (handle_name);
  if (handle != NULL)
    {
      msg (SE, _("File handle %s is already defined.  "
                 "Use %s before redefining a file handle."),
	   handle_name, "CLOSE FILE HANDLE");
      goto exit_free_handle_name;
    }

  lex_get (lexer);
  if (!lex_force_match (lexer, T_SLASH))
    goto exit_free_handle_name;

  if (!parse_file_handle (lexer, ds, &cmd, NULL))
    goto exit_free_handle_name;

  if (lex_end_of_command (lexer) != CMD_SUCCESS)
    goto exit_free_cmd;

  properties = *fh_default_properties ();
  if (cmd.s_name == NULL)
    {
      lex_sbc_missing ("NAME");
      goto exit_free_cmd;
    }

  switch (cmd.mode)
    {
    case FH_CHARACTER:
      properties.mode = FH_MODE_TEXT;
      if (cmd.sbc_tabwidth)
        {
          if (cmd.n_tabwidth[0] >= 0)
            properties.tab_width = cmd.n_tabwidth[0];
          else
            msg (SE, _("%s must not be negative."), "TABWIDTH");
        }
      if (cmd.ends == FH_LF)
        properties.line_ends = FH_END_LF;
      else if (cmd.ends == FH_CRLF)
        properties.line_ends = FH_END_CRLF;
      break;
    case FH_IMAGE:
      properties.mode = FH_MODE_FIXED;
      break;
    case FH_BINARY:
      properties.mode = FH_MODE_VARIABLE;
      break;
    case FH_360:
      properties.encoding = CONST_CAST (char *, "EBCDIC-US");
      if (cmd.recform == FH_FIXED || cmd.recform == FH_F)
        properties.mode = FH_MODE_FIXED;
      else if (cmd.recform == FH_VARIABLE || cmd.recform == FH_V)
        {
          properties.mode = FH_MODE_360_VARIABLE;
          properties.record_width = 8192;
        }
      else if (cmd.recform == FH_SPANNED || cmd.recform == FH_VS)
        {
          properties.mode = FH_MODE_360_SPANNED;
          properties.record_width = 8192;
        }
      else
        {
          msg (SE, _("%s must be specified with %s."), "RECFORM", "MODE=360");
          goto exit_free_cmd;
        }
      break;
    default:
      NOT_REACHED ();
    }

  if (properties.mode == FH_MODE_FIXED || cmd.n_lrecl[0] != LONG_MIN)
    {
      if (cmd.n_lrecl[0] == LONG_MIN)
        msg (SE, _("The specified file mode requires LRECL.  "
                   "Assuming %zu-character records."),
             properties.record_width);
      else if (cmd.n_lrecl[0] < 1 || cmd.n_lrecl[0] >= (1UL << 31))
        msg (SE, _("Record length (%ld) must be between 1 and %lu bytes.  "
                   "Assuming %zu-character records."),
             cmd.n_lrecl[0], (1UL << 31) - 1, properties.record_width);
      else
        properties.record_width = cmd.n_lrecl[0];
    }

  if (cmd.s_encoding != NULL)
    properties.encoding = cmd.s_encoding;

  fh_create_file (handle_name, cmd.s_name, &properties);

  result = CMD_SUCCESS;

exit_free_cmd:
  free_file_handle (&cmd);
exit_free_handle_name:
  free (handle_name);
exit:
  return result;
}

int
cmd_close_file_handle (struct lexer *lexer, struct dataset *ds UNUSED)
{
  struct file_handle *handle;

  if (!lex_force_id (lexer))
    return CMD_CASCADING_FAILURE;
  handle = fh_from_id (lex_tokcstr (lexer));
  if (handle == NULL)
    return CMD_CASCADING_FAILURE;

  fh_unname (handle);
  return CMD_SUCCESS;
}

/* Returns the name for REFERENT. */
static const char *
referent_name (enum fh_referent referent)
{
  switch (referent)
    {
    case FH_REF_FILE:
      return _("file");
    case FH_REF_INLINE:
      return _("inline file");
    case FH_REF_DATASET:
      return _("dataset");
    default:
      NOT_REACHED ();
    }
}

/* Parses a file handle name:

      - If SESSION is nonnull, then the parsed syntax may be the name of a
        dataset within SESSION.  Dataset names take precedence over file handle
        names.

      - If REFERENT_MASK includes FH_REF_FILE, the parsed syntax may be a file
        name as a string or a file handle name as an identifier.

      - If REFERENT_MASK includes FH_REF_INLINE, the parsed syntax may be the
        identifier INLINE to represent inline data.

   Returns the file handle when successful, a null pointer on failure.

   The caller is responsible for fh_unref()'ing the returned file handle when
   it is no longer needed. */
struct file_handle *
fh_parse (struct lexer *lexer, enum fh_referent referent_mask,
          struct session *session)
{
  struct file_handle *handle;

  if (session != NULL && lex_token (lexer) == T_ID)
    {
      struct dataset *ds;

      ds = session_lookup_dataset (session, lex_tokcstr (lexer));
      if (ds != NULL)
        {
          lex_get (lexer);
          return fh_create_dataset (ds);
        }
    }

  if (lex_match_id (lexer, "INLINE"))
    handle = fh_inline_file ();
  else
    {
      if (lex_token (lexer) != T_ID && !lex_is_string (lexer))
        {
          lex_error (lexer, _("expecting a file name or handle name"));
          return NULL;
        }

      handle = NULL;
      if (lex_token (lexer) == T_ID)
        handle = fh_from_id (lex_tokcstr (lexer));
      if (handle == NULL)
            handle = fh_create_file (NULL, lex_tokcstr (lexer),
                                     fh_default_properties ());
      lex_get (lexer);
    }

  if (!(fh_get_referent (handle) & referent_mask))
    {
      msg (SE, _("Handle for %s not allowed here."),
           referent_name (fh_get_referent (handle)));
      fh_unref (handle);
      return NULL;
    }

  return handle;
}

/*
   Local variables:
   mode: c
   End:
*/
